
//  ⮤  祭  

VOID VIOWindows_Start( LONG Settings_to_show = SET_ALL_SETTINGS )
{
 #ifdef VIOWindows_Clipboard
 bzero( &VIOWindows_Clipboard, sizeof( VIOWindows_Clipboard ) );
 #endif

 #ifdef VIOWindows_Fonts
 bzero( &VIOWindows_Fonts, sizeof( VIOWindows_Fonts ) );
 #endif

 //  ࠭,  ன ࠡ⠥ ਫ.
 LONG Code_page = Enhancer.Code_page;

 {
  //  㪠⥫  ᯨ᪥ ⠢ ⥫.
  {
   PAGE Item; PresetPageItem( &Item );

   if( Code_page == RUSSIAN ) strcpy( Item.Name, StrConst_RU_Pages_VIOWindows_clipboard_Name );
   else strcpy( Item.Name, StrConst_EN_Pages_VIOWindows_clipboard_Name );

   Item.Settings_to_show = SET_VIO_WINDOWS;
   strcpy( Item.Icon_name, "Vio_page.ico" );

   Item.CreatePage     = VIOWindows_Clipboard_CreatePage;
   Item.SetDefSettings = Marker_SetPreDefinedSettings;
   Item.ReadSettings   = Marker_ReadSettings;

   RememberPageItem( Enhancer.Pages.VIOWindows_clipboard, &Item );
  }

  //  ID  .
  VIOWindows_Clipboard.Settings.Keyboard_button_ID       = 1001;
  VIOWindows_Clipboard.Settings.Mouse_button_ID          = 1002;
  VIOWindows_Clipboard.Settings.Mouse_Shift_button_ID    = 1003;
  VIOWindows_Clipboard.Settings.Mouse_Remember_button_ID = 1004;
 }

 {
  //  㪠⥫  ᯨ᪥ ⠢ ⥫.
  {
   PAGE Item; PresetPageItem( &Item );

   if( Code_page == RUSSIAN ) strcpy( Item.Name, StrConst_RU_Pages_VIOWindows_fonts_Name );
   else strcpy( Item.Name, StrConst_EN_Pages_VIOWindows_fonts_Name );

   Item.Settings_to_show = SET_VIO_WINDOWS;
   strcpy( Item.Icon_name, "Vio_page.ico" );

   Item.CreatePage     = VIOWindows_Fonts_CreatePage;
   Item.SetDefSettings = VIOFontManager_SetPreDefinedSettings;
   Item.ReadSettings   = VIOFontManager_ReadSettings;

   RememberPageItem( Enhancer.Pages.VIOWindows_fonts, &Item );
  }

  //  ID  .
  VIOWindows_Fonts.Settings.AppList_Container_ID   = 1001;
  VIOWindows_Fonts.Settings.SelectBox_ID           = 1002;
  VIOWindows_Fonts.Settings.Selected_font_cmbox_ID = 1003;
  VIOWindows_Fonts.Settings.Application_list_ID    = 1004;
  VIOWindows_Fonts.Settings.AddRemove_ID           = 1005;
  VIOWindows_Fonts.Settings.Application_Add_ID     = 1006;
  VIOWindows_Fonts.Settings.Application_Remove_ID  = 1007;

  VIOWindows_Fonts.Settings.KnownApps_button_ID    = 1008;
  VIOWindows_Fonts.Settings.SetFont_button_ID      = 1009;
 }

 // .
 return;
}
