
//  ࠢ  

// Action । ⢨, Frame_window -  ࠬ.
VOID Arranger_ArrangeWindows( ULONG Action, HWND Frame_window )
{
 // ᫨  ᬥ  - .
 if( SynchronizeArrangerAndRooms() )
  if( Action != SM_ARRANGE_WIN_LIST )
   if( Action != SM_ARRANGE_VIO_IN_ROOM )
    if( !TimeForRoomsSwitchingIsGone() ) return;

 //   ࠡ祣 ⮫.
 HWND Desktop = QueryDesktopWindow();

 //  ᯮ   த⥫᪮  -     ࠡ祣 ⮫.
 SWP Window_placement = { 0, 0, 0, 0, 0, NULLHANDLE, NULLHANDLE, 0, 0 };
 WinQueryWindowPos( Frame_window, &Window_placement );

 // ᫨  㬥襭   - .
 if( Window_placement.fl & SWP_MINIMIZE || Window_placement.fl & SWP_HIDE )
  if( Action != SM_ARRANGE_WIN_LIST )
   return;

 //  ࠧ ࠭.
 INT X_Screen = WinQuerySysValue( Desktop, SV_CXSCREEN );
 INT Y_Screen = WinQuerySysValue( Desktop, SV_CYSCREEN );

 //    .
 INT TitleBar_height = WinQuerySysValue( Desktop, SV_CYMINMAXBUTTON );

 //      㤥 맢 .
 BYTE Activate_window = 0;

 // ࠢ ⥪⮢   室  ⠬.
 if( Action == SM_ARRANGE_VIO_IN_ROOM )
  if( Window_placement.fl & SWP_MAXIMIZE )
   Action = SM_ARRANGE_VIO;

 // ࠢ  File Commander,     ࠭.
 if( Action == SM_ARRANGE_FC2 )
  {
   if( Window_placement.cx > X_Screen ) Action = SM_ARRANGE_VIO;
   else return;
  }

 // ࠢ ⥪⮢   । ࠭.
 if( Action == SM_ARRANGE_VIO )
  {
   //   ࠧ  ᯮ .
   INT X_Size = Window_placement.cx;
   INT Y_Size = Window_placement.cy;
   INT X_Position = 0;
   INT Y_Position = 0;

   if( X_Size > X_Screen )
    {
     INT Normal_frame = FrameWidth( Frame_window );

     X_Position = Normal_frame * (-1);
     Y_Position = Y_Screen - Y_Size + Normal_frame;
    }
   else
    {
     X_Position = ( X_Screen - X_Size ) / 2;
     Y_Position = ( Y_Screen - Y_Size ) * 3 / 4;
    }

   // ᫨ ॡ ࠢ:
   if( X_Position != Window_placement.x || Y_Position != Window_placement.y || Window_placement.fl & SWP_MAXIMIZE )
    {
     // ⠭  ᯮ .
     WinSetWindowPos( Frame_window, NULLHANDLE, X_Position, Y_Position, X_Size, Y_Size, SWP_MOVE | SWP_SIZE );
    }

   //    맢 .
   Activate_window = 1;
  }

 // ࠢ  WPS  Object Desktop Archiver.
 if( Action == SM_ARRANGE_WPS )
  {
   //   ࠧ  ᯮ .
   INT X_Size = X_Screen * 3 / 4 + Rnd( TitleBar_height * 2 );
   INT Y_Size = Y_Screen * 3 / 4 + Rnd( TitleBar_height * 2 );
   INT X_Position = ( X_Screen - X_Size ) / 2;
   INT Y_Position = ( Y_Screen - Y_Size ) * 3 / 4;

   // ࠢ  WPS  । ࠭.
   // ⢨ 믮 ⮫쪮  ,  ࠧ  㬮砭.
   if( Action == SM_ARRANGE_WPS )
    {
     INT Default_width_Min = X_Screen / 1.25;
     INT Default_width_Max = X_Screen / 1.25 + 10;

    if( Window_placement.cx >= Default_width_Min && Window_placement.cx <= Default_width_Max )
     {
      WinSetWindowPos( Frame_window, NULLHANDLE, X_Position, Y_Position, X_Size, Y_Size, SWP_MOVE | SWP_SIZE );
     }
    }

   //    맢 .
   Activate_window = 1;
  }

 // ࠢ 㣨 .
 if( Action == SM_ARRANGE_WIN_LIST )
  {
   // ᫨  㢥祭 - ⠭ .
   if( Window_placement.fl & SWP_MAXIMIZE )
    {
     // ⠭ .
     PerformAction( Frame_window, RESTORE_ACTION );

     //   ࠧ  ᯮ .
     WinQueryWindowPos( Frame_window, &Window_placement );
    }

   //   ࠧ  ᯮ .
   INT X_Size = Window_placement.cx;
   INT Y_Size = Window_placement.cy;
   INT X_Position = ( X_Screen - X_Size ) / 2;
   INT Y_Position = ( Y_Screen - Y_Size ) * 3 / 4;

   // ᫨ ॡ ࠢ:
   if( X_Position != Window_placement.x || Y_Position != Window_placement.y || Window_placement.fl & SWP_MAXIMIZE )
    {
     // ⠭  ᯮ .
     WinSetWindowPos( Frame_window, NULLHANDLE, X_Position, Y_Position, X_Size, Y_Size, SWP_MOVE | SWP_SIZE );
    }
  }

 // ⠭ 
 if( Action != SM_ARRANGE_VIO ) PerformAction( Frame_window, RESTORE_ACTION );

 //   ࠭.
 if( Activate_window ) MoveWindowAbove( Frame_window );

 // .
 return;
}

//  ࠡ稪 ᮮ饭,  뫨 ।  ⮪  ࠢ  

// Message । 襤襥 ᮮ饭.
VOID Arranger_ArrangerMessageProcessing( PQMSG Message )
{
 // ⠭ ਮ  ⮪.
 if( Message->msg == SM_PRIORITY )
  {
   // ⠭ ਮ.
   LONG Class = (LONG) Message->mp1;
   LONG Delta = (LONG) Message->mp2;
   DosSetPriority( PRTYS_THREAD, Class, Delta, 0 );

   //  ਮ.
   Enhancer.Modules.Arranger->Priority = MAKELONG( Class, Delta );
  }

 // ࠢ   । ࠭.
 if( Message->msg >= SM_ARRANGE_FIRST && Message->msg <= SM_ARRANGE_LAST )
  {
   //   ࠬ  ⢨.
   HWND Frame_window = (HWND) Message->mp1;
   ULONG Action = Message->msg;

   // ᫨   - .
   if( !WinIsWindow( WinQueryAnchorBlock( Frame_window ), Frame_window ) ) return;

   // ࠢ .
   Arranger_ArrangeWindows( Action, Frame_window );
  }

 // .
 return;
}

//  ⮪  ࠢ  

VOID Arranger_ArrangerThread( VOID )
{
 // ।塞 ⮪  ⥬.
 HAB Thread = WinInitialize( 0 );

 // ᫨  ᤥ  㤠 - 室.
 if( Thread == NULLHANDLE )
  {
   //  ᮧ ⮪ ந諠 訡.
   Thread_responds.Thread_is_created = -1;

   // 室.
   return;
  }

 //  । ᮮ饭 -      ⮪.
 HMQ Message_queue = WinCreateMsgQueue( Thread, 0 ); Enhancer.Modules.Arranger->Message_queue = Message_queue;

 // ᫨ । ᮧ  㤠 - 室.
 if( Enhancer.Modules.Arranger->Message_queue == NULLHANDLE )
  {
   // 蠥 ࠡ ⮪.
   WinTerminate( Thread );

   //  ᮧ ⮪ ந諠 訡.
   Thread_responds.Thread_is_created = -1;

   // 室.
   return;
  }

 // ⮪ ᮧ ᯥ譮.
 Thread_responds.Thread_is_created = 1;

 // 祭  ࠡ⪠ ᮮ饭, 室  ⮪.
 QMSG Message = { 0, 0, 0, 0, 0, 0, 0 };
 while( WinGetMsg( Thread, &Message, 0, 0, 0 ) )
  {
   // ஢塞,    ᫥ ⠪  ᮮ饭.
   QMSG Next_message = { 0, 0, 0, 0, 0, 0, 0 };
   WinPeekMsg( Thread, &Next_message, NULLHANDLE, Message.msg, Message.msg, PM_NOREMOVE );
   if( Next_message.msg == Message.msg )
    if( Next_message.mp1 == Message.mp1 )
     if( Next_message.mp2 == Message.mp2 )
      if( Next_message.hwnd == Message.hwnd ) continue;

   // ࠡ뢠 ᮮ饭.
   Arranger_ArrangerMessageProcessing( &Message );
  }

 // 蠥 ࠡ ⮪.
 WinDestroyMsgQueue( Message_queue );
 WinTerminate( Thread );
 DosExit( EXIT_THREAD, 0 );
}
