
//    ᯨ᮪ , ᪮   ⭠ ࠭ 

VOID Scroller_InitScrList( VOID )
{
 // 塞 .
 Scroller_AddPreDefinedWindowToList( "#5", 1.00 );

 // .
 return;
}

//  ⠥ ன  । ࠦ 

VOID Scroller_ReadScrList( HINI Ini_file )
{
 // ⠥ ன.
 for( INT Count = 0; Count < SCROLLER_SCRLIST_SIZE; Count ++ )
  {
   CHAR Number[ 25 ] = ""; itoa( Count, Number, 16 ); UpperCase( Number ); CHAR Setting_name[ 50 ] = "";

   strcpy( Setting_name, "N " );
   if( strlen( Number ) == 1 ) { strcat( Setting_name, "0" ); } strcat( Setting_name, Number );
   ULONG Name = SIZE_OF_NAME; CHAR Item[ SIZE_OF_NAME ] = "";
   PrfQueryProfileData( Ini_file, "Scrolling", Setting_name, Item, &Name );

   if( Item[ 0 ] != 0 )
    {
     strcpy( Setting_name, "V " );
     if( strlen( Number ) == 1 ) { strcat( Setting_name, "0" ); } strcat( Setting_name, Number );
     ULONG Int = sizeof( INT ); ULONG Int_data = 0;
     PrfQueryProfileData( Ini_file, "Scrolling", Setting_name, &Int_data, &Int );

     if( Int_data == 1 || Int_data == 2 )
      {
       strcpy( Scroller.Scrolling_list[ Count ].Name, Item );
       Scroller.Scrolling_list[ Count ].X_Velocity = (FLOAT) Int_data;
       Scroller.Scrolling_list[ Count ].Y_Velocity = (FLOAT) Int_data;
      }
    }
  }

 // .
 return;
}

//  ஢,       ᪨ ᬮ 

// Window - , Desktop -  ࠡ祣 ⮫.
// 頥 祭: 1 - ᪨ , 0 - ᮪ .
BYTE Scroller_ScrollBarsCanBeFound( HWND Window, HWND Desktop )
{
 // ஢塞,   ᪨  .
 if( FindScrollBar( Window, SBS_VERT ) != NULLHANDLE ) return 1;
 if( FindScrollBar( Window, SBS_HORZ ) != NULLHANDLE ) return 1;

 //  த⥫᪮ .
 HWND Parent_window = WinQueryWindow( Window, QW_PARENT );
 // ᫨ த⥫᪮   - .
 if( Parent_window == Desktop ) return 0;

 // ஢塞,   ᪨  த⥫᪮ .
 if( FindScrollBar( Parent_window, SBS_VERT ) != NULLHANDLE ) return 1;
 if( FindScrollBar( Parent_window, SBS_HORZ ) != NULLHANDLE ) return 1;

 // .
 return 0;
}

//  롨ࠥ   । ࠦ 

//  ६ - 譨.
VOID Scroller_ChooseWindowForScrolling( HWND Window, PHWND Parent_window, PHWND Target_window, HWND Desktop )
{
 // ⮡  ⠢  ࠧ  । , ᯮ㥬  ६.
 HWND Parent = NULLHANDLE; HWND Target = NULLHANDLE;

 // ᫨    । ࠦ - 㤥 뫠 ᮮ饭 .
 if( Scroller_FindWindowInList( Window ) == 1 && Scroller_ScrollBarsCanBeFound( Window, Desktop ) )
  {
   // 㤥 뫠 ᮮ饭 .
   Target = Window;
   //  த⥫᪮  - ᪨   ᯮ  .
   Parent = WinQueryWindow( Window, QW_PARENT );
  }
 //  - ஢塞 த⥫᪨ .
 else
  {
   //  த⥫᪮ .
   Parent = WinQueryWindow( Window, QW_PARENT );

   // 室 த⥫᪮ ,  ஬  । ࠦ.
   while( Parent != Desktop && Parent != NULLHANDLE )
    {
     // ᫨  த⥫᪮   । ࠦ:
     if( Scroller_FindWindowInList( Parent ) == 1 && Scroller_ScrollBarsCanBeFound( Parent, Desktop ) )
      {
       // 㤥 뫠 ᮮ饭 த⥫᪮ .
       Target = Parent;
       //  ᫥饥 த⥫᪮  - ᪨   ᯮ  .
       Parent = WinQueryWindow( Parent, QW_PARENT );

       // 蠥 .
       break;
      }

     //  ᫥饥 த⥫᪮ .
     Parent = WinQueryWindow( Parent, QW_PARENT );
    }
  }

 // ⠭ 祭 譨 ६.
 *Parent_window = Parent; *Target_window = Target;

 // .
 return;
}

//  । ࠦ  ⮬ Scroll Lock 

// Window । , Scan_code 뢠,   .
VOID Scroller_ScrollImage( HWND Window, INT Scan_code )
{
 // 饭  뫠   த⥫᪮ .
 HWND Parent_window = NULLHANDLE; HWND Target_window = NULLHANDLE;

 //   ࠡ祣 ⮫.
 HWND Desktop = QueryDesktopWindow();

 // 롨ࠥ   । ࠦ.
 Scroller_ChooseWindowForScrolling( Window, &Parent_window, &Target_window, Desktop );

 // ᫨     ࠭ - .
 if( Target_window == NULLHANDLE ) return;

 //    । ࠦ  .
 BYTE Reply = Scroller_PermissionForKeyScrolling( Target_window ); if( !Reply ) return;
 //      뫠 ⥫ ᮮ饭.
 BYTE Supplementary_messages = 0; if( Reply == 2 ) Supplementary_messages = 1;

 //  ६,  㤥 ᮤঠ ﭨ ᪨ ᬮ.
 SBCDATA SB_State = { 0, 0, 0, 0, 0, 0, 0 };

 // ᫨  ५    - ஢塞 ﭨ ᪨ ᢥ ,
 //  ᫨  ५   ࠢ - ஢塞 ﭨ ᪨ ᫥ ࠢ.
 BYTE SB_Type = 0; if( Scan_code == SC_UP || Scan_code == SC_DOWN ) SB_Type = SBS_VERT; else SB_Type = SBS_HORZ;

 // ᪠   ᯮ  ᠬ . ᫨ ࠦ
 // ।  த⥫᪮  - 뢠 ᯮ .
 HWND SB_Control = NULLHANDLE;

 if( Target_window != Window )
  {
   //  ᯮ   த⥫᪮ .
   SWP Window_placement = { 0, 0, 0, 0, 0, NULLHANDLE, NULLHANDLE, 0, 0 };
   WinQueryWindowPos( Window, &Window_placement );

   // 饬   த⥫᪮ . ᪠   ᯮ ⠪ ,  
   // . ᫨  ᯮ  ஭  ,       ᪠.
   SB_Control = FindScrollBar( Target_window, SB_Type, &Window_placement );
  }
 else
  {
   SB_Control = FindScrollBar( Target_window, SB_Type );
  }

 // ᫨ ᪠  - 㧭,    ﭨ.
 if( SB_Control != NULLHANDLE )
  {
   // ,   ﭨ ᪠.
   QueryScrollBarState( SB_Control, &SB_State );
  }
 // ᫨ ᪨  -    ᯮ 冷  .
 else
  {
   // ஢塞,   । ࠦ  த⥫᪮ .
   Reply = Scroller_PermissionForKeyScrolling( Parent_window );

   // ᫨   - 室   .
   if( Reply != 0 )
    {
     //  ᯮ ࠭   த⥫᪮ .
     SWP Window_placement = { 0, 0, 0, 0, 0, NULLHANDLE, NULLHANDLE, 0, 0 };
     WinQueryWindowPos( Target_window, &Window_placement );

     // 饬   த⥫᪮ . ᪠   ᯮ ⠪ ,  
     // . ᫨  ᯮ  ஭  ,       ᪠.
     SB_Control = FindScrollBar( Parent_window, SB_Type, &Window_placement );

     // ᫨ ᪠  - 㧭,    ﭨ.
     if( SB_Control != NULLHANDLE ) QueryScrollBarState( SB_Control, &SB_State );

     // ᫨   - ஢塞 த⥫᪮ .
     // ᫨    ࠬ - ,    뫠 ⥫ ᮮ饭.
     if( !( SB_State.posFirst == 0 && SB_State.posLast == 0 ) )
      if( Reply == 2 )
       if( !IsFrameWindow( Parent_window ) )
        Supplementary_messages = 1;
    }
  }

 // ᫨ ᪠ ⪫祭    - .
 if( !SB_State.sHilite || ( SB_State.posFirst == 0 && SB_State.posLast == 0 ) ) return;

 // ᫨  ⨣  ᪨ - .
 if( Scan_code == SC_UP || Scan_code == SC_LEFT ) if( SB_State.posThumb == SB_State.posFirst ) return;
 if( Scan_code == SC_DOWN || Scan_code == SC_RIGHT ) if( SB_State.posThumb == SB_State.posLast ) return;

 // ⠢塞 ᮮ饭,   ᫠ .
 ULONG Message = 0; SHORT Command = 0;
 if( Scan_code == SC_UP ) { Message = WM_VSCROLL; Command = SB_LINEUP; }
 if( Scan_code == SC_DOWN ) { Message = WM_VSCROLL; Command = SB_LINEDOWN; }
 if( Scan_code == SC_RIGHT ) { Message = WM_HSCROLL; Command = SB_LINEDOWN; }
 if( Scan_code == SC_LEFT ) { Message = WM_HSCROLL; Command = SB_LINEUP; }

 //  ࠦ   ப.
 HWND Owner_window = WinQueryWindow( SB_Control, QW_OWNER );
 SHORT SB_Id = WinQueryWindowUShort( SB_Control, QWS_ID );
 WinPostMsg( Owner_window, Message, (MPARAM) SB_Id, MPFROM2SHORT( 0, Command ) );

 // 뫠 ᮮ饭  ⨨  ⦠⨨ ५ , ᫨  ॡ.
 if( Supplementary_messages == 1 )
  {
   // ⪫砥 । ࠦ   ५.
   Scroller.Settings.Key_scrolling = 0;

   // ⠢塞 ᮮ饭  ⨨   ५.
   MPARAM First_parameter_1 = 0; MPARAM Second_parameter_1 = 0;
   MPARAM First_parameter_2 = 0; MPARAM Second_parameter_2 = 0;
   ComposeWMCharMessage( &First_parameter_1, &Second_parameter_1, &First_parameter_2, &Second_parameter_2, Scan_code, 0, 0 );

   // 뫠    ⢥.
   WinSendMsg( Window, WM_CHAR, First_parameter_1, Second_parameter_1 );
   WinSendMsg( Window, WM_CHAR, First_parameter_2, Second_parameter_2 );

   //  砥 । ࠦ   ५.
   Scroller.Settings.Key_scrolling = 1;
  }

 // .
 return;
}

//  稭 । ࠦ    

// Window । , X  Y - ᯮ 㪠⥫   ࠭.
VOID Scroller_BeginDragging( HWND Window, INT X, INT Y )
{
 // 饭  뫠   த⥫᪮ .
 HWND Parent_window = NULLHANDLE; HWND Target_window = NULLHANDLE;

 //   ࠡ祣 ⮫.
 HWND Desktop = QueryDesktopWindow();

 // 롨ࠥ   । ࠦ.
 Scroller_ChooseWindowForScrolling( Window, &Parent_window, &Target_window, Desktop );
 // ᫨     ࠭ - .
 if( Target_window == NULL ) return;

 //    । ࠦ  .
 if( !Scroller_PermissionForScrolling( Target_window ) ) return;

 //  ᪮ । ࠦ  .
 SCRLIST Record_from_list = { NULL, 0, 0 }; Scroller_QueryScrollingVelocity( Target_window, &Record_from_list );

 // ᫨ ᪮  ࠢ 1  2 - .
 BYTE Speed_is_correct = 0;
 if( Record_from_list.X_Velocity == 1.00 || Record_from_list.X_Velocity == 2.00 ) Speed_is_correct = 1;
 if( Record_from_list.X_Velocity != Record_from_list.Y_Velocity ) Speed_is_correct = 0;
 if( !Speed_is_correct ) return;

 // ,   । ࠦ   .
 Scroller.RTSettings.Smooth_scrolling_is_permitted = 1;
 if( !Scroller_PermissionForScrolling( Target_window, 1 ) ) Scroller.RTSettings.Smooth_scrolling_is_permitted = 0;
 if( !Scroller_PermissionForScrolling( Parent_window, 1 ) ) Scroller.RTSettings.Smooth_scrolling_is_permitted = 0;

 //  ६  ࠡ  ᪠ ᬮ.
 HWND SB_Control = NULLHANDLE;
 SBCDATA SB_State = { 0, 0, 0, 0, 0, 0, 0 };

 // 室 ᪨  .
 Scroller.RTSettings.VSB_Control = NULLHANDLE; Scroller.RTSettings.HSB_Control = NULLHANDLE;
 for( INT Count = 0; Count < 2; Count ++ )
  {
   //   ᪨,   .
   BYTE SB_Type = SBS_VERT; if( Count == 1 ) SB_Type = SBS_HORZ;
   // , 뫮   ४祭  த⥫᪮ .
   BYTE Switching_to_parent = 0;

   // ᪠   ᯮ  ᠬ . ᫨ ࠦ
   // ।  த⥫᪮  - 뢠 ᯮ .
   if( !Switching_to_parent )
    if( Target_window != Window )
     {
      //  ᯮ   த⥫᪮ .
      SWP Window_placement = { 0, 0, 0, 0, 0, NULLHANDLE, NULLHANDLE, 0, 0 };
      WinQueryWindowPos( Window, &Window_placement );

      // 饬   த⥫᪮ . ᪠   ᯮ ⠪ ,  
      // . ᫨  ᯮ  ஭  ,       ᪠.
      SB_Control = FindScrollBar( Target_window, SB_Type, &Window_placement );
     }
    else SB_Control = FindScrollBar( Target_window, SB_Type );

   // ᫨ ᪠  - 㧭,    ﭨ.
   if( SB_Control != NULLHANDLE )
    {
     // ,   ﭨ ᪠.
     QueryScrollBarState( SB_Control, &SB_State );
    }
   // ᫨ ᪨  -    ᯮ 冷  .
   else
    {
     // ᫨  த⥫᪮   । ࠦ - 室   .
     if( Scroller_PermissionForScrolling( Parent_window ) )
      {
       //  ᯮ ࠭   த⥫᪮ .
       SWP Window_placement = { 0, 0, 0, 0, 0, NULLHANDLE, NULLHANDLE, 0, 0 };
       WinQueryWindowPos( Target_window, &Window_placement );

       // 饬   த⥫᪮ . ᪠   ᯮ ⠪ ,  
       // . ᫨  ᯮ  ஭  ,       ᪠.
       SB_Control = FindScrollBar( Parent_window, SB_Type, &Window_placement );

       // ᫨ ᪠  - 㧭,    ﭨ.
       if( SB_Control != NULLHANDLE ) QueryScrollBarState( SB_Control, &SB_State );

       // ᫨   - ஢塞 த⥫᪮ .
       if( !( SB_State.posFirst == 0 && SB_State.posLast == 0 ) )
        {
         // ᫨    ࠬ - 㧭 ᪮  .
         if( !IsFrameWindow( Parent_window ) )
          {
           //  ᪮ । ࠦ  .
           Scroller_QueryScrollingVelocity( Parent_window, &Record_from_list );

           // ,   । ࠦ   .
           Scroller.RTSettings.Smooth_scrolling_is_permitted = Scroller_PermissionForScrolling( Parent_window, 1 );
          }

         // ,  뫮 ४祭  த⥫᪮ .
         Switching_to_parent = 1;
        }
      }
    }

   //  , ᫨  뫠 .
   if( SB_Control != NULLHANDLE )
    {
     if( Count == 0 ) Scroller.RTSettings.VSB_Control = SB_Control;
     else Scroller.RTSettings.HSB_Control = SB_Control;
    }
  }

 // ᫨   ᮪  - .
 SBCDATA VSB_State = { 0, 0, 0, 0, 0, 0, 0 }; QueryScrollBarState( Scroller.RTSettings.VSB_Control, &VSB_State );
 SBCDATA HSB_State = { 0, 0, 0, 0, 0, 0, 0 }; QueryScrollBarState( Scroller.RTSettings.HSB_Control, &HSB_State );
 if( !VSB_State.sHilite || ( VSB_State.posFirst == 0 && VSB_State.posLast == 0 ) )
  if( !HSB_State.sHilite || ( HSB_State.posFirst == 0 && HSB_State.posLast == 0 ) )
   return;

 //   㪠⥫ .
 Scroller.RTSettings.Begin_point.x = X; Scroller.RTSettings.Begin_point.y = Y;
 Scroller.RTSettings.Old_point.x = X;   Scroller.RTSettings.Old_point.y = Y;

 //  ᪮ । ࠦ  .
 Scroller.RTSettings.X_Velocity = Record_from_list.X_Velocity;
 Scroller.RTSettings.Y_Velocity = Record_from_list.Y_Velocity;

 // ⠭  㪠⥫ .
 if( Resources.Pointer_for_dragging != NULLHANDLE )
  WinSetPointer( QueryDesktopWindow(), Resources.Pointer_for_dragging );

 //  - ।!
 Scroller.RTSettings.Travel = 1;

 // .
 return;
}

//  । ࠦ  ࠭  

// X  Y - ᯮ 㪠⥫   ࠭.
VOID Scroller_DragImage( INT X, INT Y )
{
 // ,   ﭨ ᪨ ᬮ.
 SBCDATA VSB_State = { 0, 0, 0, 0, 0, 0, 0 };
 if( WinIsWindow( WinQueryAnchorBlock( Scroller.RTSettings.VSB_Control ), Scroller.RTSettings.VSB_Control ) )
  QueryScrollBarState( Scroller.RTSettings.VSB_Control, &VSB_State );

 SBCDATA HSB_State = { 0, 0, 0, 0, 0, 0, 0 };
 if( WinIsWindow( WinQueryAnchorBlock( Scroller.RTSettings.HSB_Control ), Scroller.RTSettings.HSB_Control ) )
  QueryScrollBarState( Scroller.RTSettings.HSB_Control, &HSB_State );

 // 뢠,  ᮮ饭 뫮 ᫠.
 BYTE Sent = 0; HWND Owner_window = NULLHANDLE;

 // । ࠦ ᢥ .
 if( Y != Scroller.RTSettings.Old_point.y )
  {
   //    ᪨ ᬮ.
   INT New_position = -1;

   // ᫨ 㪠⥫ ।㫨 , ⭠ ᪮  । ࠦ :
   if( Y < Scroller.RTSettings.Old_point.y ) if( Scroller.RTSettings.Y_Velocity != 0 )
    if( VSB_State.posThumb > VSB_State.posFirst )
     if( VSB_State.sHilite )
      if( !( VSB_State.posFirst == 0 && VSB_State.posLast == 0 ) )
       {
        // ,  ﭨ 襫 㪠⥫.
        INT Distance = Scroller.RTSettings.Old_point.y - Y;

        //     ᪨ ᬮ.
        New_position = VSB_State.posThumb - Distance / Scroller.RTSettings.Y_Velocity;
        if( New_position < VSB_State.posFirst ) New_position = VSB_State.posFirst;

        // ᫨     - । ࠦ  .
        if( New_position == VSB_State.posThumb ) New_position = -1;
       }

   // ᫨ 㪠⥫ ।㫨 , ⭠ ᪮  । ࠦ :
   if( Y > Scroller.RTSettings.Old_point.y ) if( Scroller.RTSettings.Y_Velocity != 0 )
    if( VSB_State.posThumb < VSB_State.posLast )
     if( VSB_State.sHilite )
      if( !( VSB_State.posFirst == 0 && VSB_State.posLast == 0 ) )
       {
        // ,  ﭨ 襫 㪠⥫.
        INT Distance = Y - Scroller.RTSettings.Old_point.y;

        //     ᪨ ᬮ.
        New_position = VSB_State.posThumb + Distance / Scroller.RTSettings.Y_Velocity;
        if( New_position > VSB_State.posLast ) New_position = VSB_State.posLast;

        // ᫨     - । ࠦ  .
        if( New_position == VSB_State.posThumb ) New_position = -1;
       }

   // ᫨ 뫮     ᪨ ᬮ - 뫠 ᮮ饭.
   if( New_position != -1 )
    {
     // 뫠 ᮮ饭.
     Owner_window = WinQueryWindow( Scroller.RTSettings.VSB_Control, QW_OWNER );
     SHORT SB_Id = WinQueryWindowUShort( Scroller.RTSettings.VSB_Control, QWS_ID );
     if( Scroller.RTSettings.Smooth_scrolling_is_permitted ) WinPostMsg( Owner_window, WM_VSCROLL, (MPARAM) SB_Id, MPFROM2SHORT( New_position, SB_SLIDERTRACK ) );
     WinPostMsg( Owner_window, WM_VSCROLL, (MPARAM) SB_Id, MPFROM2SHORT( New_position, SB_SLIDERPOSITION ) );

     // ,  ᮮ饭 뫨 ᫠.
     Sent = 1;
    }
  }

 // । ࠦ ᫥ ࠢ.
 if( X != Scroller.RTSettings.Old_point.x )
  {
   //    ᪨ ᬮ.
   INT New_position = -1;

   // ᫨ 㪠⥫ ।㫨 ࠢ, ⭠ ᪮  । ࠦ :
   if( X > Scroller.RTSettings.Old_point.x ) if( Scroller.RTSettings.X_Velocity != 0 )
    if( HSB_State.posThumb > HSB_State.posFirst )
     if( HSB_State.sHilite )
      if( !( HSB_State.posFirst == 0 && HSB_State.posLast == 0 ) )
       {
        // ,  ﭨ 襫 㪠⥫.
        INT Distance = X - Scroller.RTSettings.Old_point.x;

        //     ᪨ ᬮ.
        New_position = HSB_State.posThumb - Distance / Scroller.RTSettings.X_Velocity;
        if( New_position < HSB_State.posFirst ) New_position = HSB_State.posFirst;

        // ᫨     - । ࠦ  .
        if( New_position == HSB_State.posThumb ) New_position = -1;
       }

   // ᫨ 㪠⥫ ।㫨 , ⭠ ᪮  । ࠦ :
   if( X < Scroller.RTSettings.Old_point.x ) if( Scroller.RTSettings.X_Velocity != 0 )
    if( HSB_State.posThumb < HSB_State.posLast )
     if( HSB_State.sHilite )
      if( !( HSB_State.posFirst == 0 && HSB_State.posLast == 0 ) )
       {
        // ,  ﭨ 襫 㪠⥫.
        INT Distance = Scroller.RTSettings.Old_point.x - X;

        //     ᪨ ᬮ.
        New_position = HSB_State.posThumb + Distance / Scroller.RTSettings.X_Velocity;
        if( New_position > HSB_State.posLast ) New_position = HSB_State.posLast;

        // ᫨     - । ࠦ  .
        if( New_position == HSB_State.posThumb ) New_position = -1;
       }

   // ᫨ 뫮     ᪨ ᬮ - 뫠 ᮮ饭.
   if( New_position != -1 )
    {
     // 뫠 ᮮ饭.
     Owner_window = WinQueryWindow( Scroller.RTSettings.HSB_Control, QW_OWNER );
     SHORT SB_Id = WinQueryWindowUShort( Scroller.RTSettings.HSB_Control, QWS_ID );
     if( Scroller.RTSettings.Smooth_scrolling_is_permitted ) WinPostMsg( Owner_window, WM_HSCROLL, (MPARAM) SB_Id, MPFROM2SHORT( New_position, SB_SLIDERTRACK ) );
     WinPostMsg( Owner_window, WM_HSCROLL, (MPARAM) SB_Id, MPFROM2SHORT( New_position, SB_SLIDERPOSITION ) );

     // ,  ᮮ饭 뫨 ᫠.
     Sent = 1;
    }
  }

 // ᫨ ᮮ饭 뫨 ᫠, :
 if( Sent )
  {
   //    㪠⥫ .
   Scroller.RTSettings.Old_point.x = X; Scroller.RTSettings.Old_point.y = Y;

   // ⠭  㪠⥫ .
   if( Resources.Pointer_for_dragging != NULLHANDLE )
    WinSetPointer( QueryDesktopWindow(), Resources.Pointer_for_dragging );

   //  ࠡ⪥ ᮮ饭   ⠭ ᢮ 㪠⥫. 뫠  ।
   //  ᮮ饭 WM_MARK -   㤥 祭, 㪠⥫  㤥 .
   if( Resources.Pointer_for_dragging != NULLHANDLE )
    {
     HMQ Message_queue = WinQueryWindowULong( Owner_window, QWL_HMQ );
     WinPostQueueMsg( Message_queue, WM_MARK, (MPARAM) MRK_SET_POINTER, (MPARAM) NULLHANDLE );
    }
  }

 // .
 return;
}

//  蠥 । ࠦ    

VOID Scroller_EndDragging( VOID )
{
 // 蠥 ।.
 Scroller.RTSettings.Travel = 0;

 // ᢮ 㪠⥫ .
 ResetPointer();

 // .
 return;
}

//  ࠡ稪 ᮮ饭,  뫨 ।  ⮪  । ࠦ 

// Message । 襤襥 ᮮ饭.
VOID Scroller_ScrollerMessageProcessing( PQMSG Message )
{
 // ⠭ ਮ  ⮪.
 if( Message->msg == SM_PRIORITY )
  {
   // ⠭ ਮ.
   LONG Class = (LONG) Message->mp1;
   LONG Delta = (LONG) Message->mp2;
   DosSetPriority( PRTYS_THREAD, Class, Delta, 0 );

   //  ਮ.
   Enhancer.Modules.Scroller->Priority = MAKELONG( Class, Delta );
  }

 // । ࠦ  ⨨    ५.
 if( Message->msg == SM_SC_LINE )
  {
   //     .
   HWND Window = (HWND) Message->mp1;
   INT Scan_code = (INT) Message->mp2;

   // ᫨   - .
   if( !WinIsWindow( WinQueryAnchorBlock( Window ), Window ) ) return;

   // । ࠦ.
   Scroller_ScrollImage( Window, Scan_code );
  }

 // 稭 । ࠦ   .
 if( Message->msg == SM_SC_BEGIN )
  {
   //  .
   HWND Window = (HWND) Message->mp1;

   // ᫨   - .
   if( !WinIsWindow( WinQueryAnchorBlock( Window ), Window ) ) return;

   // ᫨    Ctrl -   ࠭.
   if( !CtrlIsPressed() ) MoveWindowAbove( QueryFrameWindow( Window ) );

   //  ᯮ 㪠⥫ .
   POINT Pointer = { 0, 0 }; WinQueryPointerPos( QueryDesktopWindow(), &Pointer );

   // 稭 ।.
   Scroller_BeginDragging( Window, Pointer.x, Pointer.y );
  }

 // । ࠦ.
 if( Message->msg == SM_SC_DRAG )
  if( Scroller.RTSettings.Travel )
   {
    //  ᯮ 㪠⥫ .
    POINT Pointer = { 0, 0 }; WinQueryPointerPos( QueryDesktopWindow(), &Pointer );

    //  ண ஢: ᫨ 㪠⥫  ⮬   - .
    if( Pointer.x == Scroller.RTSettings.Old_point.x )
     if( Pointer.y == Scroller.RTSettings.Old_point.y )
      return;

    // । ࠦ.
    Scroller_DragImage( Pointer.x, Pointer.y );
   }

 // 蠥 ।.
 if( Message->msg == SM_SC_END ) Scroller_EndDragging();

 // .
 return;
}

//  ⮪  । ࠦ   

VOID Scroller_ScrollerThread( VOID )
{
 // ।塞 ⮪  ⥬.
 HAB Thread = WinInitialize( 0 );

 // ᫨  ᤥ  㤠 - 室.
 if( Thread == NULLHANDLE )
  {
   //  ᮧ ⮪ ந諠 訡.
   Thread_responds.Thread_is_created = -1;

   // 室.
   return;
  }

 //  । ᮮ饭 -      ⮪.
 HMQ Message_queue = WinCreateMsgQueue( Thread, 0 ); Enhancer.Modules.Scroller->Message_queue = Message_queue;

 // ᫨ । ᮧ  㤠 - 室.
 if( Enhancer.Modules.Scroller->Message_queue == NULLHANDLE )
  {
   // 蠥 ࠡ ⮪.
   WinTerminate( Thread );

   //  ᮧ ⮪ ந諠 訡.
   Thread_responds.Thread_is_created = -1;

   // 室.
   return;
  }

 // ⮪ ᮧ ᯥ譮.
 Thread_responds.Thread_is_created = 1;

 // 祭  ࠡ⪠ ᮮ饭, 室  ⮪.
 QMSG Message = { 0, 0, 0, 0, 0, 0, 0 };
 while( WinGetMsg( Thread, &Message, 0, 0, 0 ) )
  {
   // ஢塞,    ᫥ ⠪  ᮮ饭.
   QMSG Next_message = { 0, 0, 0, 0, 0, 0, 0 };
   WinPeekMsg( Thread, &Next_message, NULLHANDLE, Message.msg, Message.msg, PM_NOREMOVE );
   if( Next_message.msg == Message.msg )
    if( Next_message.mp1 == Message.mp1 )
     if( Next_message.mp2 == Message.mp2 )
      if( Next_message.hwnd == Message.hwnd ) continue;

   // ࠡ뢠 ᮮ饭.
   Scroller_ScrollerMessageProcessing( &Message );
  }

 // 蠥 ࠡ ⮪.
 WinDestroyMsgQueue( Message_queue );
 WinTerminate( Thread );
 DosExit( EXIT_THREAD, 0 );
}
